import { defineNuxtModule, addVitePlugin, addWebpackPlugin } from '@nuxt/kit';
import VitePlugin from './vite.mjs';
import WebpackPlugin from './webpack.mjs';
import './index.mjs';
import '@vue.ts/common';
import '@vue.ts/language';
import 'unplugin';
import 'magic-string';
import 'typescript';
import 'node:path';

const name = "@vue.ts/complex-types";
const version = "0.5.0";

const nuxt = defineNuxtModule({
  meta: {
    name,
    version,
    configKey: "complexTypes",
    compatibility: {
      bridge: true
    }
  },
  defaults: {
    tsconfigPath: "tsconfig.json"
  },
  setup(options) {
    addVitePlugin(VitePlugin(options));
    addWebpackPlugin(WebpackPlugin(options));
  }
});

export { nuxt as default };
