import { BaseOptions } from '@vue.ts/common';
import MagicString from 'magic-string';
import ts from 'typescript';

declare class Printer {
    private checker;
    constructor(checker: ts.TypeChecker);
    private getBaseType;
    private printIntersectionTypeNode;
    private printUnionTypeNode;
    private printTypeLiteralNode;
    private printByType;
    printTypeArg(node: ts.Node): string;
    private printEventsByCallSignatures;
    private printEventsByMembers;
    printEventsRuntimeArg(node: ts.Node): string;
}

type ValidTransforms = "defineEmits" | "defineProps";
type Options = {
    tsconfigPath?: string;
} & {
    [Transform in ValidTransforms]?: boolean;
} & BaseOptions;
type ResolvedOptions = Required<Options>;
type TransformOptions = Pick<ResolvedOptions, ValidTransforms>;
type Transformer = (printer: Printer, s: MagicString, id: string) => void;
type Transformers = [ValidTransforms, Transformer][];

export type { Options, ResolvedOptions, TransformOptions, Transformer, Transformers, ValidTransforms };
